--[[
      --<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--


      #           #   ###########        #######           ####       #         #  ##   ###########        #           #   #   #######      ###########
      #           #   #                  #      ##       ##    ##     ##        #   ##       #             #           #   #   #      ##    #
      #           #   #                  #        #     #        #    # #       #    ##      #             #           #   #   #        #   #
      #     #     #   #                  #         #   #          #   #  ##     #            #             #     #     #   #   #      ##    #
      #     #     #   ###########        #         #   #          #   #    #    #            #             #     #     #   #   #######      ###########
       #   # #   #    #                  #         #   #          #   #     ##  #            #              #   # #   #    #   #            #
       #   # #   #    #                  #        #     #        #    #       # #            #              #   # #   #    #   #            #
        # #   # #     #                  #      ##       ##    ##     #        ##            #               # #   # #     #   #            #
         #     #      ###########        #######           ####       #         #            #                #     #      #   #            ###########


      --<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--


                                                             ----o----(||)----o----(||)----o----

                                                                          FROST MAGE
                                                                          ~~~~~~~~~~

                                                                   v3.01 25th October 2016
                                                                  Copyright (C) Chris Birch

                                                             ----o----(||)----o----(||)----o----


               Note: This is a module for the We Don't Wipe AddOn. You need to download the latest We Don't Wipe in order to use this module
]]


--[[ ================== ]]--
--[[     Local Data     ]]-- ===============================================================================================================
--[[ ================== ]]-- 

local icyveins, jet, maxfof, rof, shat, tier3, wait, debug = "n", "y", 2, "y", 1.5, "y", 0.4, "n"

local playerLevel = 0
local nextPos, elapsedNextPos = 1, 0
local hastenedDivisor = 1
local startRoP = 1000
local curChargesFoF, maxChargesFoF, expiresFoF = 0, 0, 0
local expiresRoP, cdLeftRoP, chargesRoP = 1000, 1000, 10
local hastenedDivisor = 1
local hasRoF, hasMI, hasRoP, hasF, hasFBomb = false, false, false, false, false

local GetMeleeHaste = GetMeleeHaste
local GetSpellCharges = GetSpellCharges
local GetTalentInfo = GetTalentInfo
local GetTime = GetTime
local GetTotemInfo = GetTotemInfo
local IsSpellKnown = IsSpellKnown
local UnitDetailedThreatSituation = UnitDetailedThreatSituation
local UnitExists = UnitExists
local UnitLevel = UnitLevel

local abs = math.abs
local floor = math.floor
local modf = math.modf

local function round( num, places )		-- round to nearest integer, ties round away from zero
	local mult = 10 ^ ( places or 0 )
	return modf( num * mult + ( ( num < 0 and -1 ) or 1 ) * 0.5 ) / mult
end

--[[ ================ ]]--
--[[     Rotation     ]]-- =================================================================================================================
--[[ ================ ]]-- 

wdwMod_Rotations["FrostMage"] = {}
wdwMod_Rotations["FrostMage"]["Single"] = {

	["Version"] = "3.01",
	["WDW Version"] = "5.08",
	["Template"] = "1.05",

	["Rotation"] = {"Setup", "FlurryLance", "ExpiringFoF", "CappedFoF", "BigBang", "RefreshRoP", "BrainFreeze", "JetDebuff",
			"FrostLance", "Spike", "Filler", },
	["Parameters"] = {"DB", "List", "icyveins", "jet", "maxfof", "rof", "shat", "tier3", "wait", "debug" },
	["Notes"] = "Legion Patch 7.1 - Return to Karahzan",

	["maxfof"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "maxfof".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
					( WDW_FrostMageDB.maxfof or "nil").. wdw_colour_Jasmine..
					" (".. wdw_colour_SelectiveYellow.. "2".. wdw_colour_Jasmine.. "/".. wdw_colour_SelectiveYellow..
					"3".. wdw_colour_Jasmine.. ". Select \"2\" if you do NOT have the Icy Hand trait. "..
					wdw_colour_SelectiveYellow.. "Default \"3\"".. wdw_colour_Jasmine.. ")" )
				return
			end
			local fofMax = floor( abs( tonumber( arg ) ) )
			WDW_FrostMageDB[ "maxfof" ] = ( ( fofMax >= 2 ) and ( fofMax <= 3 ) ) and waitAmount or 2
		end
		if not WDW_FrostMageDB[ "maxfof" ] then
			WDW_FrostMageDB[ "maxfof" ] = 3
		end
		maxfof = WDW_FrostMageDB[ "maxfof" ]
	end,

	["icyveins"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "icyveins".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
					( WDW_FrostMageDB.icyveins or "nil").. wdw_colour_Jasmine..
					" (".. wdw_colour_SelectiveYellow.. "y".. wdw_colour_Jasmine.. "/".. wdw_colour_SelectiveYellow..
					"n".. wdw_colour_Jasmine.. ". Whether to include Icy Veins in the rotation. "..
					wdw_colour_SelectiveYellow.. "Default \"n\"".. wdw_colour_Jasmine.. ")" )
				return
			end
			WDW_FrostMageDB[ "icyveins" ] = ( arg == "y" ) and "y" or "n"
		end
		if not WDW_FrostMageDB[ "icyveins" ] then
			WDW_FrostMageDB[ "icyveins" ] = "n"
		end
		icyveins = WDW_FrostMageDB[ "icyveins" ]
	end,

	["jet"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "jet".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
					( WDW_FrostMageDB.jet or "nil").. wdw_colour_Jasmine..
					" (".. wdw_colour_SelectiveYellow.. "y".. wdw_colour_Jasmine.. "/".. wdw_colour_SelectiveYellow..
					"n".. wdw_colour_Jasmine.. ". Whether to include Water Jet in the rotation. "..
					wdw_colour_SelectiveYellow.. "Default \"y\"".. wdw_colour_Jasmine.. ")" )
				return
			end
			WDW_FrostMageDB[ "jet" ] = ( arg == "y" ) and "y" or "n"
		end
		if not WDW_FrostMageDB[ "jet" ] then
			WDW_FrostMageDB[ "jet" ] = "y"
		end
		jet = WDW_FrostMageDB[ "jet" ]
	end,

	["rof"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "rof".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
					( WDW_FrostMageDB.rof or "nil").. wdw_colour_Jasmine..
					" (".. wdw_colour_SelectiveYellow.. "y".. wdw_colour_Jasmine.. "/".. wdw_colour_SelectiveYellow..
					"n".. wdw_colour_Jasmine.. ". Whether to include Ray of Frost in the rotation. "..
					wdw_colour_SelectiveYellow.. "Default \"y\"".. wdw_colour_Jasmine.. ")" )
				return
			end
			WDW_FrostMageDB[ "rof" ] = ( arg == "y" ) and "y" or "n"
		end
		if not WDW_FrostMageDB[ "rof" ] then
			WDW_FrostMageDB[ "rof" ] = "y"
		end
		rof = WDW_FrostMageDB[ "rof" ]
	end,

	["shat"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "shat".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
					( WDW_FrostMageDB.shat or "nil").. wdw_colour_Jasmine..
					" (".. wdw_colour_SelectiveYellow.. ">= 0".. wdw_colour_Jasmine.. " to ".. wdw_colour_SelectiveYellow..
					"<= 100".. wdw_colour_Jasmine.. ". See online description as very detailed. "..
					wdw_colour_SelectiveYellow.. "Default \"1.5\"".. wdw_colour_Jasmine.. ")" )
				return
			end
			local shatNum = tonumber( arg )
			WDW_FrostMageDB[ "shat" ] = ( ( shatNum >= 0 ) and ( shatNum <= 100 ) ) and shatNum or 1.5
		end
		if not WDW_FrostMageDB[ "shat" ] then
			WDW_FrostMageDB[ "shat" ] = 1.5
		end
		shat = WDW_FrostMageDB[ "shat" ]
	end,

	["tier3"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "rof".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
					( WDW_FrostMageDB.rof or "nil").. wdw_colour_Jasmine..
					" (".. wdw_colour_SelectiveYellow.. "y".. wdw_colour_Jasmine.. "/".. wdw_colour_SelectiveYellow..
					"n".. wdw_colour_Jasmine.. ". Whether to include Rune of Power or Mirror Image in the rotation. "..
					wdw_colour_SelectiveYellow.. "Default \"y\"".. wdw_colour_Jasmine..
					". Incanter's Flow is passive)" )
				return
			end
			WDW_FrostMageDB[ "tier3" ] = ( arg == "y" ) and "y" or "n"
		end
		if not WDW_FrostMageDB[ "tier3" ] then
			WDW_FrostMageDB[ "tier3" ] = "y"
		end
		tier3 = WDW_FrostMageDB[ "tier3" ]
	end,

	["wait"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "wait".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
					( WDW_FrostMageDB.wait or "nil").. wdw_colour_Jasmine..
					" (".. wdw_colour_SelectiveYellow.. "0".. wdw_colour_Jasmine.. " to ".. wdw_colour_SelectiveYellow..
					"1.5".. wdw_colour_Jasmine.. " seconds. At times an ability might not be exactly ready to use as "..
					"it is cooling down or recharging. The default is to allow an ability to appear in its queue "..
					"position up to 400ms before it is ready. "..
					wdw_colour_SelectiveYellow.. "Default \"0.4\"".. wdw_colour_Jasmine.. ")" )
				return
			end
			local waitAmount = tonumber( arg )
			WDW_FrostMageDB[ "wait" ] = ( ( waitAmount >= 0 ) and ( waitAmount <= 1.5 ) ) and waitAmount or 0.4
		end
		if not WDW_FrostMageDB[ "wait" ] then
			WDW_FrostMageDB[ "wait" ] = 0.4
		end
		wait = WDW_FrostMageDB[ "wait" ]
	end,

	["debug"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "debug".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
					( WDW_FrostMageDB.debug or "nil").. wdw_colour_Jasmine..
					" (".. wdw_colour_SelectiveYellow.. "y".. wdw_colour_Jasmine.. "/".. wdw_colour_SelectiveYellow..
					"n".. wdw_colour_Jasmine.. ". Parameter used by the author. "..
					wdw_colour_SelectiveYellow.. "Default \"n\"".. wdw_colour_Jasmine.. ")" )
				return
			end
			WDW_FrostMageDB[ "debug" ] = ( arg == "y" ) and "y" or "n"
		end
		if not WDW_FrostMageDB[ "debug" ] then
			WDW_FrostMageDB[ "debug" ] = "n"
		end
		debug = WDW_FrostMageDB[ "debug" ]
	end,

	["DB"] = function ()

		if WDW_FrostMageDB then
			if ( WDW_FrostMageDB.Legion == nil ) then
				WDW_FrostMageDB = {}
				WDW_FrostMageDB.Legion = true
			end
		else
			WDW_FrostMageDB = {}
			WDW_FrostMageDB.Legion = true
		end
	end,

	["List"] = function ()

		print( wdw_colour_SelectiveYellow.. "Frost Mage parameters:\n"..
			wdw_colour_MalachiteGreen.. "maxfof".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
				( maxfof or "nil" ).. wdw_colour_Jasmine.. ", ".. 
			wdw_colour_MalachiteGreen.. "icyveins".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
				( icyveins or "nil" ).. wdw_colour_Jasmine.. ", ".. 
			wdw_colour_MalachiteGreen.. "jet".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
				( jet or "nil" ).. wdw_colour_Jasmine.. ", ".. 
			wdw_colour_MalachiteGreen.. "rof".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
				( rof or "nil" ).. wdw_colour_Jasmine.. ", ".. 
			wdw_colour_MalachiteGreen.. "tier3".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
				( tier3 or "nil" ).. wdw_colour_Jasmine.. ", "..
			wdw_colour_MalachiteGreen.. "shat".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
				( shat or "nil" ).. wdw_colour_Jasmine.. ", ".. 
			wdw_colour_MalachiteGreen.. "wait".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
				( wait or "nil" ) ) 
	end,

	["Setup"] = function ()

		playerLevel = UnitLevel( "player" )

		nextPos, elapsedNextPos = 1, wdw_GCD

		startRoP = 1000

		curChargesFoF = wdw_buffsPlayer["44544"] and wdw_buffsPlayer["44544"].count or 0
		maxChargesFoF = maxfof	-- NOTE: NO WAY TO TEST FOR TRAIT RAISE TO THREE
		expiresFoF = wdw_buffsPlayer["44544"] and wdw_buffsPlayer["44544"].expires or 0

		hastenedDivisor = 1 + ( GetMeleeHaste() / 100 )

		hasRoF = select( 4, GetTalentInfo( 1, 1, 1 ) )
		hasMI = select( 4, GetTalentInfo( 3, 1, 1 ) )
		hasRoP = select( 4, GetTalentInfo( 3, 2, 1 ) )
		hasFT = select( 4, GetTalentInfo( 4, 2, 1 ) )
		hasFBomb = select( 4, GetTalentInfo( 6, 1, 1 ) )

		if ( hasRoP == true ) and ( tier3 =="y" ) then
			local _, _, startTime, duration = GetTotemInfo(1)
			expiresRoP = ( startTime == 0 ) and 0 or ( startTime + duration - GetTime() )
			cdLeftRoP = WeDontWipe_CooldownLeft( 116011 )
			chargesRoP = GetSpellCharges( 116011 )
		else
			expiresRoP = 1000
			cdLeftRoP = 1000
			chargesRoP = 0
		end
	end,

	["FlurryLance"] = function ()	-- Instant Flurrys cause an extra 1s debuff 228358 which makes the target take an IL as though frozen

		if ( playerLevel < 20 ) or ( nextPos > WeDontWipeDB.queueLength ) or ( wdw_debuffsTarget["228358"] == nil ) then return end
		if ( wdw_debuffsTarget["228358"].expires > elapsedNextPos ) then
			-- See Brain Freeze section below for notes re the rubbery 1s by Blizzard
			-- No time to dump FoF

			if ( debug == "y" ) then print( "FlurryLance e=".. round( wdw_debuffsTarget["228358"].expires, 3 ).. 
				" t=".. round( elapsedNextPos, 3 ) ) end

			wdw_Queue[ nextPos ] = 30455
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			curChargesFoF = ( curChargesFoF > 0 ) and ( curChargesFoF - 1 ) or 0
			expiresFoF = ( curChargesFoF > 0 ) and expiresFoF or 0
		end
	end,

	["ExpiringFoF"] = function ()	-- Level 24 passive

		if ( playerLevel < 24 ) or ( nextPos > WeDontWipeDB.queueLength ) or ( curChargesFoF == 0 ) then return end

		if expiresFoF <= ( elapsedNextPos + ( curChargesFoF * wdw_GCDtop ) ) then

			if ( debug == "y" ) then print( "ExpiringFoF e=".. round( expiresFoF, 3 ).. " t="..
				round( elapsedNextPos + ( curChargesFoF * wdw_GCDtop ), 3 ) ) end

			if ( curChargesFoF > 0 ) then
				wdw_Queue[ nextPos ] = 30455
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				curChargesFoF = curChargesFoF - 1
			end
			if ( curChargesFoF > 0 ) then
				wdw_Queue[ nextPos ] = 30455
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				curChargesFoF = curChargesFoF - 1
			end
			if ( curChargesFoF > 0 ) then
				wdw_Queue[ nextPos ] = 30455
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				curChargesFoF = curChargesFoF - 1
			end
			expiresFoF = 0
		end
	end,

	["CappedFoF"] = function ()	-- Level 24 passive

		if ( playerLevel < 24 ) or ( nextPos > WeDontWipeDB.queueLength ) or ( curChargesFoF < maxChargesFoF ) then return end

		if ( expiresFoF >= elapsedNextPos ) then
			wdw_Queue[ nextPos ] = 30455
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			curChargesFoF = curChargesFoF - 1
		end
	end,

	["BigBang"] = function ()	-- Coordinating RoP -> MI -> IV -> RoF -> FBomb -> Orb -> FT -> EB -> WJ

		if ( nextPos > WeDontWipeDB.queueLength ) then return end

		local offset = elapsedNextPos
		local cdLeftMI, cdLeftRoF, cdLeftIV, curCharges, expiresFB = 1000, 1000, 1000, 0, 1000

		if ( expiresRoP <= offset ) then
			if ( chargesRoP > 0 ) then
				offset = offset + ( 1.5 / hastenedDivisor ) + wdw_GCDtop
				curCharges = chargesRoP
			else
				if ( cdLeftRoP <= offset ) then
					offset = offset + ( 1.5 / hastenedDivisor ) + wdw_GCDtop
					curCharges = 1
				end
			end
		end
--
--This block could have coordinated cool downs. IV website has pros and cons for this though

		if ( hasMI == true ) and ( tier3 =="y" ) then
			cdLeftMI = WeDontWipe_CooldownLeft( 55342 )
			if ( ( cdLeftMI - wait ) <= offset ) then
				offset = offset + wdw_GCDtop
			end
		end
		if ( playerLevel >= 40 ) and ( icyveins == "y" ) then
			cdLeftIV = WeDontWipe_CooldownLeft( 12472 )
			if ( ( cdLeftIV - wait ) <= offset ) then
				offset = offset + 0.075
			end
		end
--
		if ( hasRoF == true ) and ( rof == "y" ) then
			cdLeftRoF = WeDontWipe_CooldownLeft( 205021 )
			if ( ( cdLeftRoF - wait ) <= offset ) then
				offset = offset + 10 + wdw_GCDtop	-- lol - that's 10s channel
			end
		end
		if ( hasFBomb == true ) then
			if wdw_debuffsTarget["112948"] then
				if ( wdw_debuffsTarget["112948"].expires <= offset ) then
					expiresFB = wdw_debuffsTarget["112948"].expires
					offset = offset + ( 1.5 / hastenedDivisor ) + wdw_GCDtop
				end
			else
				expiresFB = 0
				offset = offset + ( 1.5 / hastenedDivisor ) + wdw_GCDtop
			end
		end

		local leadInDone = false

		if ( playerLevel >= 57 ) then
			local cdLeftOrb = WeDontWipe_CooldownLeft( 84714 )
			if ( ( cdLeftOrb - wait ) <= offset ) then

				if ( leadInDone == false ) then

					if ( debug == "y" ) then print( "BB Orb o=".. round( offset, 3).. " RoP=".. curCharges.. " MI=".. round( ( cdLeftMI - wait ), 3 )..
						" IV=".. round( ( cdLeftIV - wait ), 3 ).. " RoF=".. round( ( cdLeftRoF - wait ), 3 )..
						" FB=".. round( expiresFB, 3 ) ) end

					if ( curCharges > 0 ) then
						wdw_Queue[ nextPos ] = 116011
						nextPos = nextPos + 1
						startRoP = elapsedNextPos + ( 1.5 / hastenedDivisor )
						elapsedNextPos = elapsedNextPos + ( 1.5 / hastenedDivisor ) + wdw_GCDtop
						if ( nextPos > WeDontWipeDB.queueLength ) then return end
					end
					if ( ( cdLeftMI - wait ) <= offset ) then
						wdw_Queue[ nextPos ] = 55342
						nextPos = nextPos + 1
						elapsedNextPos = elapsedNextPos + wdw_GCDtop
						if ( nextPos > WeDontWipeDB.queueLength ) then return end
					end
					if ( ( cdLeftIV - wait ) <= offset ) then
						wdw_Queue[ nextPos ] = 12472
						nextPos = nextPos + 1
						elapsedNextPos = elapsedNextPos + 0.075
						if ( nextPos > WeDontWipeDB.queueLength ) then return end
					end
					if ( ( cdLeftRoF - wait ) <= offset ) then
						wdw_Queue[ nextPos ] = 205021
						nextPos = nextPos + 1
						elapsedNextPos = elapsedNextPos + 10 + wdw_GCDtop
						if ( nextPos > WeDontWipeDB.queueLength ) then return end
					end
					if ( hasFBomb == true ) and ( expiresFB <= offset ) then
						wdw_Queue[ nextPos ] = 112948
						nextPos = nextPos + 1
						elapsedNextPos = elapsedNextPos + ( 1.5 / hastenedDivisor ) + wdw_GCDtop
						if ( nextPos > WeDontWipeDB.queueLength ) then return end
					end
					leadInDone = true
				end

				if ( ( curChargesFoF + 1 ) > maxChargesFoF ) then
					wdw_Queue[ nextPos ] = 30455
					nextPos = nextPos + 1
					elapsedNextPos = elapsedNextPos + wdw_GCDtop
					curChargesFoF = curChargesFoF - 1
					if ( nextPos > WeDontWipeDB.queueLength ) then return end
				end

				wdw_Queue[ nextPos ] = 84714
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				curChargesFoF = curChargesFoF + 1
				expiresFoF = 15
				if ( nextPos > WeDontWipeDB.queueLength ) then return end
				offset = elapsedNextPos
			end
		end

		if ( hasFT == true ) then
			local cdLeftFT = WeDontWipe_CooldownLeft( 205030 )
			if ( ( cdLeftFT - wait ) <= offset ) then

				if ( leadInDone == false ) then

					if ( debug == "y" ) then print( "BB FT o=".. round( offset, 3).. " RoP=".. curCharges.. " MI=".. round( ( cdLeftMI - wait ), 3 )..
						" IV=".. round( ( cdLeftIV - wait ), 3 ).. " RoF=".. round( ( cdLeftRoF - wait ), 3 )..
						" FB=".. round( expiresFB, 3 ) ) end

					if ( curCharges > 0 ) then
						wdw_Queue[ nextPos ] = 116011
						nextPos = nextPos + 1
						startRoP = elapsedNextPos + ( 1.5 / hastenedDivisor )
						elapsedNextPos = elapsedNextPos + ( 1.5 / hastenedDivisor ) + wdw_GCDtop
						if ( nextPos > WeDontWipeDB.queueLength ) then return end
					end
					if ( ( cdLeftMI - wait ) <= offset ) then
						wdw_Queue[ nextPos ] = 55342
						nextPos = nextPos + 1
						elapsedNextPos = elapsedNextPos + wdw_GCDtop
						if ( nextPos > WeDontWipeDB.queueLength ) then return end
					end
					if ( ( cdLeftIV - wait ) <= offset ) then
						wdw_Queue[ nextPos ] = 12472
						nextPos = nextPos + 1
						elapsedNextPos = elapsedNextPos + 0.075
						if ( nextPos > WeDontWipeDB.queueLength ) then return end
					end
					if ( ( cdLeftRoF - wait ) <= offset ) then
						wdw_Queue[ nextPos ] = 205021
						nextPos = nextPos + 1
						elapsedNextPos = elapsedNextPos + 10 + wdw_GCDtop
						if ( nextPos > WeDontWipeDB.queueLength ) then return end
					end
					if ( hasFBomb == true ) and ( expiresFB <= offset ) then
						wdw_Queue[ nextPos ] = 112948
						nextPos = nextPos + 1
						elapsedNextPos = elapsedNextPos + ( 1.5 / hastenedDivisor ) + wdw_GCDtop
						if ( nextPos > WeDontWipeDB.queueLength ) then return end
					end
					leadInDone = true
				end

				if ( ( curChargesFoF + 2 ) > maxChargesFoF ) then
					wdw_Queue[ nextPos ] = 30455
					nextPos = nextPos + 1
					elapsedNextPos = elapsedNextPos + wdw_GCDtop
					curChargesFoF = curChargesFoF - 1
					if ( nextPos > WeDontWipeDB.queueLength ) then return end
				end
				if ( ( curChargesFoF + 2 ) > maxChargesFoF ) then
					wdw_Queue[ nextPos ] = 30455
					nextPos = nextPos + 1
					elapsedNextPos = elapsedNextPos + wdw_GCDtop
					curChargesFoF = curChargesFoF - 1
					if ( nextPos > WeDontWipeDB.queueLength ) then return end
				end

				wdw_Queue[ nextPos ] = 205030
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + 0.075
				curChargesFoF = curChargesFoF + 2
				expiresFoF = 15
				if ( nextPos > WeDontWipeDB.queueLength ) then return end
				offset = elapsedNextPos
			end
		end

		if ( IsSpellKnown( 214634 ) == true ) then
			local cdLeftEB = WeDontWipe_CooldownLeft( 214634 )
			if ( ( cdLeftEB - wait ) <= offset ) then

				if ( leadInDone == false ) then

					if ( debug == "y" ) then print( "BB EB o=".. round( offset, 3).. " RoP=".. curCharges.. " MI=".. round( ( cdLeftMI - wait ), 3 )..
						" IV=".. round( ( cdLeftIV - wait ), 3 ).. " RoF=".. round( ( cdLeftRoF - wait ), 3 )..
						" FB=".. round( expiresFB, 3 ) ) end

					if ( curCharges > 0 ) then
						wdw_Queue[ nextPos ] = 116011
						nextPos = nextPos + 1
						startRoP = elapsedNextPos + ( 1.5 / hastenedDivisor )
						elapsedNextPos = elapsedNextPos + ( 1.5 / hastenedDivisor ) + wdw_GCDtop
						if ( nextPos > WeDontWipeDB.queueLength ) then return end
					end
					if ( ( cdLeftMI - wait ) <= offset ) then
						wdw_Queue[ nextPos ] = 55342
						nextPos = nextPos + 1
						elapsedNextPos = elapsedNextPos + wdw_GCDtop
						if ( nextPos > WeDontWipeDB.queueLength ) then return end
					end
					if ( ( cdLeftIV - wait ) <= offset ) then
						wdw_Queue[ nextPos ] = 12472
						nextPos = nextPos + 1
						elapsedNextPos = elapsedNextPos + 0.075
						if ( nextPos > WeDontWipeDB.queueLength ) then return end
					end
					if ( ( cdLeftRoF - wait ) <= offset ) then
						wdw_Queue[ nextPos ] = 205021
						nextPos = nextPos + 1
						elapsedNextPos = elapsedNextPos + 10 + wdw_GCDtop
						if ( nextPos > WeDontWipeDB.queueLength ) then return end
					end
					if ( hasFBomb == true ) and ( expiresFB <= offset ) then
						wdw_Queue[ nextPos ] = 112948
						nextPos = nextPos + 1
						elapsedNextPos = elapsedNextPos + ( 1.5 / hastenedDivisor ) + wdw_GCDtop
						if ( nextPos > WeDontWipeDB.queueLength ) then return end
					end
					leadInDone = true
				end

				if ( ( curChargesFoF + 2 ) > maxChargesFoF ) then
					wdw_Queue[ nextPos ] = 30455
					nextPos = nextPos + 1
					elapsedNextPos = elapsedNextPos + wdw_GCDtop
					curChargesFoF = curChargesFoF - 1
					if ( nextPos > WeDontWipeDB.queueLength ) then return end
				end
				if ( ( curChargesFoF + 2 ) > maxChargesFoF ) then
					wdw_Queue[ nextPos ] = 30455
					nextPos = nextPos + 1
					elapsedNextPos = elapsedNextPos + wdw_GCDtop
					curChargesFoF = curChargesFoF - 1
					if ( nextPos > WeDontWipeDB.queueLength ) then return end
				end

				wdw_Queue[ nextPos ] = 214634
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + ( 3 / hastenedDivisor ) + wdw_GCDtop
				curChargesFoF = curChargesFoF + 2
				expiresFoF = 15
				if ( nextPos > WeDontWipeDB.queueLength ) then return end
				offset = elapsedNextPos
			end
		end

		if ( IsSpellKnown( 135029 , true ) == true ) and ( jet == "y" ) then
			local cdLeftWJ = WeDontWipe_CooldownLeft( 135029 )
			if ( ( cdLeftWJ - wait ) <= offset ) then

				if ( leadInDone == false ) then

					if ( debug == "y" ) then print( "BB WJ o=".. round( offset, 3).. " RoP=".. curCharges.. " MI=".. round( ( cdLeftMI - wait ), 3 )..
						" IV=".. round( ( cdLeftIV - wait ), 3 ).. " RoF=".. round( ( cdLeftRoF - wait ), 3 )..
						" FB=".. round( expiresFB, 3 ) ) end

					if ( curCharges > 0 ) then
						wdw_Queue[ nextPos ] = 116011
						nextPos = nextPos + 1
						startRoP = elapsedNextPos + ( 1.5 / hastenedDivisor )
						elapsedNextPos = elapsedNextPos + ( 1.5 / hastenedDivisor ) + wdw_GCDtop
						if ( nextPos > WeDontWipeDB.queueLength ) then return end
					end
					if ( ( cdLeftMI - wait ) <= offset ) then
						wdw_Queue[ nextPos ] = 55342
						nextPos = nextPos + 1
						elapsedNextPos = elapsedNextPos + wdw_GCDtop
						if ( nextPos > WeDontWipeDB.queueLength ) then return end
					end
					if ( ( cdLeftIV - wait ) <= offset ) then
						wdw_Queue[ nextPos ] = 12472
						nextPos = nextPos + 1
						elapsedNextPos = elapsedNextPos + 0.075
						if ( nextPos > WeDontWipeDB.queueLength ) then return end
					end
					if ( ( cdLeftRoF - wait ) <= offset ) then
						wdw_Queue[ nextPos ] = 205021
						nextPos = nextPos + 1
						elapsedNextPos = elapsedNextPos + 10 + wdw_GCDtop
						if ( nextPos > WeDontWipeDB.queueLength ) then return end
					end
					if ( hasFBomb == true ) and ( expiresFB <= offset ) then
						wdw_Queue[ nextPos ] = 112948
						nextPos = nextPos + 1
						elapsedNextPos = elapsedNextPos + ( 1.5 / hastenedDivisor ) + wdw_GCDtop
						if ( nextPos > WeDontWipeDB.queueLength ) then return end
					end
					leadInDone = true
				end

				if ( ( curChargesFoF + 2 ) > maxChargesFoF ) then
					wdw_Queue[ nextPos ] = 30455
					nextPos = nextPos + 1
					elapsedNextPos = elapsedNextPos + wdw_GCDtop
					curChargesFoF = curChargesFoF - 1
					if ( nextPos > WeDontWipeDB.queueLength ) then return end
				end
				if ( ( curChargesFoF + 2 ) > maxChargesFoF ) then
					wdw_Queue[ nextPos ] = 30455
					nextPos = nextPos + 1
					elapsedNextPos = elapsedNextPos + wdw_GCDtop
					curChargesFoF = curChargesFoF - 1
					if ( nextPos > WeDontWipeDB.queueLength ) then return end
				end

				wdw_Queue[ nextPos ] = 146976	-- Special replacement icon
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + 0.075
				if ( nextPos > WeDontWipeDB.queueLength ) then return end
				wdw_Queue[ nextPos ] = 116
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				curChargesFoF = curChargesFoF + 1
				expiresFoF = 15
				curChargesFoF = ( curChargesFoF > maxChargesFoF ) and maxChargesFoF or curChargesFoF
				if ( nextPos > WeDontWipeDB.queueLength ) then return end
				wdw_Queue[ nextPos ] = 116
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				curChargesFoF = curChargesFoF + 1
				expiresFoF = 15
				curChargesFoF = ( curChargesFoF > maxChargesFoF ) and maxChargesFoF or curChargesFoF
				if ( nextPos > WeDontWipeDB.queueLength ) then return end
				wdw_Queue[ nextPos ] = 30455
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				offset = elapsedNextPos
			end
		end
	end,

	["RefreshRoP"] = function ()	-- 116011 Tier 3 / Level 45 Talent. 10s duration, 1.5s cast, GCD. 2 charges, 40s recharge

		if ( playerLevel < 45 ) or ( nextPos > WeDontWipeDB.queueLength ) or ( hasRoP == false ) or ( tier3 =="n" ) or ( startRoP <= elapsedNextPos ) then return end

		if ( expiresRoP <= elapsedNextPos ) then
			if ( chargesRoP > 1 ) or ( ( chargesRoP == 1 ) and ( cdLeftRoP <= elapsedNextPos ) ) then
				wdw_Queue[ nextPos ] = 116011
				nextPos = nextPos + 1
				startRoP = elapsedNextPos + ( 1.5 / hastenedDivisor )
				elapsedNextPos = elapsedNextPos + ( 1.5 / hastenedDivisor ) + wdw_GCDtop
			end
		end
	end,

	["BrainFreeze"] = function ()	-- 15s player buff 190446. Makes next Flurry instant cast (down from 3s) and "freezes" the target

		if ( nextPos > WeDontWipeDB.queueLength ) or ( wdw_buffsPlayer["190446"] == nil ) then return end

		if ( ( wdw_buffsPlayer["190446"].expires - ( curChargesFoF * ( wdw_GCDtop + wait ) ) ) < elapsedNextPos ) then
			if ( debug == "y" ) then print("BrainFreeze ABORTED c=".. curChargesFoF.. " e=".. wdw_buffsPlayer["190446"].expires) end
			return
		end

		-- Dump FoF. Damn bad luck if the player acquires a FoF during a BF

		if ( debug == "y" ) then print("BrainFreeze c=".. curChargesFoF.. " e=".. round( wdw_buffsPlayer["190446"].expires, 3 ) ) end

		if ( curChargesFoF > 0 ) then
			wdw_Queue[ nextPos ] = 30455
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			if ( nextPos > WeDontWipeDB.queueLength ) then return end
			curChargesFoF = curChargesFoF - 1
		end
		if ( curChargesFoF > 0 ) then
			wdw_Queue[ nextPos ] = 30455
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			if ( nextPos > WeDontWipeDB.queueLength ) then return end
			curChargesFoF = curChargesFoF - 1
		end
		if ( curChargesFoF > 0 ) then
			wdw_Queue[ nextPos ] = 30455
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			if ( nextPos > WeDontWipeDB.queueLength ) then return end
			curChargesFoF = curChargesFoF - 1
		end
		expiresFoF = 0

		wdw_Queue[ nextPos ] = 44614	-- Flurry
		nextPos = nextPos + 1
		elapsedNextPos = elapsedNextPos + wdw_GCDtop
		if ( nextPos > WeDontWipeDB.queueLength ) then return end

		-- The Flurry causes TWO very short debuffs on the target, both 1s and both named Flurry. 228358 (as if frozen)(only from instant Flurry) and 228354 (slow)
		-- Testing reveals some sleight of hand: Flurry has a GCD but IL can be cast some time during this GCD but not right at the start
		-- The 1s countdown does the Blizzard WoD GCD/cd stutter

		wdw_Queue[ nextPos ] = 30455	-- Ice Lance
		nextPos = nextPos + 1
		elapsedNextPos = elapsedNextPos + wdw_GCDtop
		if ( nextPos > WeDontWipeDB.queueLength ) then return end
	end,

	["JetDebuff"] = function ()	-- Water Jet 135029 Debuff on target. 4s duration. Mini-rotation Frostbolt->Frostbolt->Ice Lance

		if ( nextPos > WeDontWipeDB.queueLength ) or ( wdw_debuffsTarget["135029"] == nil ) then return end

		-- 4s debuff starts about 1s after the WJ begins channeling. The Ice Lance can be cast on top of the final FB
		-- So total elapsed time about 2 * frostboltCastTime + wdw_GCDtop, which will be under 4s for a properly hastened player

		-- Unable to test: Player acquires at level 32. But can a sub-32 player take advantage of this debuff (applied by another frost mage?)

		local frostboltCastTime = 2 / hastenedDivisor
		local expires = wdw_debuffsTarget["135029"].expires

		if ( debug == "y" ) then print("JetDebuff t=".. round( 2 * frostboltCastTime + wdw_GCDtop, 3 ).. " e=".. round( expires, 3) ) end

		if ( expires > elapsedNextPos ) and ( expires > ( 2 * frostboltCastTime + wdw_GCDtop ) ) then
			wdw_Queue[ nextPos ] = 116
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			curChargesFoF = curChargesFoF + 1
			expiresFoF = 15
			curChargesFoF = ( curChargesFoF > maxChargesFoF ) and maxChargesFoF or curChargesFoF
			if ( nextPos > WeDontWipeDB.queueLength ) then return end
		end
		if ( expires > elapsedNextPos ) and ( expires > ( frostboltCastTime ) ) then
			wdw_Queue[ nextPos ] = 116
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			curChargesFoF = curChargesFoF + 1
			expiresFoF = 15
			curChargesFoF = ( curChargesFoF > maxChargesFoF ) and maxChargesFoF or curChargesFoF
			if ( nextPos > WeDontWipeDB.queueLength ) then return end
		end
		if ( expires > elapsedNextPos ) and ( expires < frostboltCastTime ) then
			wdw_Queue[ nextPos ] = 30455
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			if ( nextPos > WeDontWipeDB.queueLength ) then return end
		end
	end,

	["FrostLance"] = function ()	-- Player has to cast Frostbolt and before the cast has finished do an Ice Lance

		if ( playerLevel < 10 ) or ( nextPos > WeDontWipeDB.queueLength ) then return end

		if ( expiresFoF >= ( elapsedNextPos + ( 2 / hastenedDivisor ) ) ) and ( expiresFoF <= ( elapsedNextPos + ( shat * 2 / hastenedDivisor ) ) ) then

			if ( debug == "y" ) then print( "FrostLance l=".. round( elapsedNextPos + ( 2 / hastenedDivisor ), 3 ).. " h=".. 
				round( elapsedNextPos + ( shat * 2 / hastenedDivisor ), 3 ).. " e=".. round( expiresFoF, 3 ) ) end

			wdw_Queue[ nextPos ] = 116
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			if ( nextPos > WeDontWipeDB.queueLength ) then return end
			wdw_Queue[ nextPos ] = 30455
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			curChargesFoF = curChargesFoF - 1
			expiresFoF = ( curChargesFoF > 0 ) and expiresFoF or 0
		end
	end,

	["Spike"] = function () -- Glacial Spike 199786. Level 100. 3s cast, GCD. 40 yards range

		if ( playerLevel < 100 ) or ( nextPos > WeDontWipeDB.queueLength ) then return end

		if wdw_buffsPlayer["205473"] and ( wdw_buffsPlayer["205473"].count >= 5 ) then	-- Icicles
			if ( wdw_buffsPlayer["205473"].expires > elapsedNextPos ) then
				wdw_Queue[ nextPos ] = 199786
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
			end
		end
	end,			

	["Filler"] = function () -- Frostbolt

		for i = nextPos, WeDontWipeDB.queueLength do
			if ( wdw_Queue[ i ] == 0 ) then
				wdw_Queue[ i ] = 116
			end
		end
	end,			

}